﻿Imports System.IO.Ports 'Записать самой первой строкой всей программы

Public Class Form1



    
    ' ПЕРВЫЙ ВАРИАНТ инициализации последовательного порта
    Sub SendSerialData(ByVal cifra As Integer) ' Отправляет в порт значение переменной "cifra" (при вызове подпрограммы указывается в скобках)

        Dim cifra2(2) As Byte ' Описывается массив

        ' Открывается порт и указываются параметры его работы
        Using SelectedPort As IO.Ports.SerialPort = My.Computer.Ports.OpenSerialPort("COM10", 9600, IO.Ports.Parity.None, 8, IO.Ports.StopBits.One)

            SelectedPort.WriteTimeout = 3000

            cifra2(1) = cifra
            SelectedPort.Write(cifra2, 1, 1) ' В порт отправляется байт данных 
            '                           (массив "cifra2" ; смещение 1 (от нулевого байта); один байт)

            SelectedPort.Close() ' Порт закрывается

        End Using

    End Sub

    
    ' ВТОРОЙ ВАРИАНТ инициализации последовательного порта
    ' В нем необходимо самой первой строкой ВСЕЙ программы записать "Imports System.IO.Ports" 
    Sub ReceiveSerialPort()
        Dim returnValue As Integer
        Dim byteInBuffer As Integer


        Using SelectedPort As New SerialPort
            With SelectedPort
                .PortName = "COM10"
                .BaudRate = 9600
                .DataBits = 8
                .Parity = Parity.None
                .StopBits = StopBits.One
                .Handshake = Handshake.None
            End With

            Try
                SelectedPort.Open()
            Catch ex As Exception
                MessageBox.Show(ex.Message)
            End Try

            SelectedPort.ReadTimeout = 3000

            For i As Integer = 1 To 100000

                byteInBuffer = SelectedPort.BytesToRead
                If byteInBuffer = 0 Then Continue For

                ListBox1.Items.Add("Buffer")
                ListBox1.Items.Add(byteInBuffer)

                returnValue = SelectedPort.ReadByte
                ListBox1.Items.Add(returnValue)

            Next i

            SelectedPort.Close()

        End Using

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        SendSerialData(45)
    End Sub

    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        SendSerialData(0)
    End Sub

    'Zagruzka
    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
        ReceiveSerialPort()

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        End
    End Sub
End Class
